package j2gether.model;

import java.io.Serializable;

/**
 * <p>Title: J2Gether</p>
 *
 * <p>Description: Primeiro trabalho prtico P4</p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: 4thFloor</p>
 *
 * @author Srgio Lopes, Ruben Pedro
 * @version 1.0
 */
public class Peca implements Serializable{

    /**
     * Representao inteira da cor da pea
     */
    private int cor;

    /**
     * Indica se a pea se encontra seleccionada
     */
    private boolean candidata;

    /**
     * Posio do tabuleiro em que se encontra a pea
     */
    private Posicao posicao;

    /**
     * Constante que representa a cor incolor
     */
    public static final int INCOLOR = -1;

    public Peca(Posicao posicao, int cor) {
        this.cor = cor;
        this.posicao = posicao;
    }

    public int getCor() {
        return cor;
    }

    public Posicao getPosicao() {
        return posicao;
    }

    public boolean isCandidata() {
        return candidata;
    }

    public boolean isIncolor() {
        return cor == INCOLOR;
    }

    public void setPosicao(Posicao novaPosicao) {
        posicao = novaPosicao;
    }

    public void setCor(int cor) {
        this.cor = cor;
    }


    /**
     * Seleciona a pea
     */
    public void select() {
        candidata = true;
    }

    /**
     * Desselecciona a pea
     */
    public void deSelect() {
        candidata = false;
    }

    /**
     * Compara uma determinada cor com a cor da pea
     *
     * @param cor cor a comparar
     * @return boolean indicando se as cores so iguais ou no
     */
    public boolean sameColour(int cor) {
        return this.cor == cor;
    }

    /**
     * Atribui a cor INCOLOR  pea
     */
    public void ocultar() {
        cor = INCOLOR;
    }

    public String toString() {
        return Integer.toString(cor);
    }


}
