package j2gether.model;

/**
 * <p>Title: J2Gether</p>
 *
 * <p>Description: Primeiro trabalho prtico P4</p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: 4thFloor</p>
 *
 * @author Srgio Lopes, Ruben Pedro
 * @version 1.0
 */
public final class ScoreMode {

    private int numLinhasTabuleiro;
    private int numColunasTabuleiro;
    private int numCores;

	/**
	 * Constri um ScoreMode que contm as informaes do jogo actual
	 *
	 * @param numLinhasTabuleiro nmero de linhas do jogo actual
	 * @param numColunasTabuleiro nmero de colunas do jogo actual
	 * @param numCores nmero de cores usadas no jogo actual
	 */
    public ScoreMode(int numLinhasTabuleiro, int numColunasTabuleiro, int numCores)
	{
        this.numLinhasTabuleiro = numLinhasTabuleiro;
        this.numColunasTabuleiro = numColunasTabuleiro;
        this.numCores = numCores;
    }

    /**
     * Obtm o nmero de linhas do tabuleiro
     *
     * @return o nmero de linhas do tabuleiro que corresponde  pontuao a construir
     */
    public int getNumLinhasTabuleiro() {
        return numLinhasTabuleiro;
    }

    /**
     * Obtm o nmero de cores do tabuleiro
     *
     * @return o nmero de cores utilizadas no tabuleiro que corresponde  pontuao a construir
     */
    public int getNumCores() {
        return numCores;
    }

    /**
     * Obtm o nmero de colunas do tabuleiro
     *
     * @return o nmero de colunas do tabuleiro que corresponde  pontuao a construir
     */
    public int getNumColunasTabuleiro() {
        return numColunasTabuleiro;
    }
}
